
//--------------------------------------
//	init.edit 
//	
//	2006/05/01-
//	1991-2002 Copyright Tabasa & charlie, All rights reserved
//
//


#define	_main

#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "initial.h"
#include "file.h"
#include "info.h"

BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
HINSTANCE hInstance;
//char filename[MAX_PATH];
char AppName[]="initedit";
#define buffermax 64000
int edittopX=5;
int edittopY=35;
int defX=160;
int defY=370;

int posstep=1000;
char buffer [buffermax+1]="ready.";
ULONG length=1000;
ifstream in;
HWND hwndEdit,hwndMain;

ULONG pos;
const int prmax=13;
profile pr[prmax];
char value[MAX_PATH];

int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
	hInstance=hInst;
	
//	sprintf(commandline,"%s",szCmdLine);
     if (-1 == DialogBox (hInstance, AppName, NULL, (int (__stdcall *)(void))DlgProc))
     {
          MessageBox (NULL, TEXT ("error"),
                      AppName, MB_ICONERROR) ;
     }
     return 0 ;
}


void save()
{
}


//--------------------------------------
//	C



BOOL CALLBACK DlgProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	//PAINTSTRUCT	paintstruct;
	 //HDC hdc;
	 WORD cxClient,cyClient;

	 ULONG i;
	

     switch (message)
     {
		case WM_INITDIALOG:
			hwndMain=hwnd;
			PopFileInitialize (hwnd);
			SetWindowText(hwnd,exename);
			SetClassLong(hwnd,GCL_HICON,
				(long)LoadIcon(hInstance,"main") );
		/*	
          hwndEdit = CreateWindow (TEXT ("edit"), NULL,
                           WS_CHILD | WS_VISIBLE |WS_HSCROLL | WS_VSCROLL |
                                   WS_BORDER | ES_LEFT | ES_MULTILINE |
                                   ES_AUTOHSCROLL | ES_AUTOVSCROLL,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                         hwnd, NULL, hInstance,NULL) ;
		  pos=0;*/
		  SendMessage (hwnd, WM_SIZE, 0 , (LPARAM) MAKELONG(defY,defX) ) ;
		return TRUE ;
          
	case WM_DROPFILES:
		//DragQueryFile((HDROP)wParam,0,pathname,MAX_PATH);
		break;

     case WM_SIZE : 
          cxClient = LOWORD (lParam) ;
          cyClient = HIWORD (lParam) ;
		 MoveWindow (hwndEdit, edittopX, edittopY,
                           cxClient-edittopX-5, cyClient-edittopY-5, TRUE) ;
         return 0 ;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case IDC_FILE_OPEN:
			  for(i=0;i<prmax;i++) pr[i].reset();
			  PopFileOpenDlg (hwnd,pr[0].file,AppName);
			  for(i=1;i<prmax;i++) pr[i].setfile(pr[0].file);
			  SetDlgItemText(hwnd,IDC_file, pr[0].file);
			  SendMessage (hwnd, WM_COMMAND, IDC_next_key , 0) ;
			  break;

		  case IDC_next_key:
			  pr[0].keyplus(1);
			  for(i=1;i<prmax;i++) pr[i].setkeynum(pr[0].key_num);
			  SendMessage (hwnd, WM_COMMAND, IDC_setkey , 0) ;
			  break;

		  case IDC_back_key:
			  pr[0].keyplus(-1);
			  for(i=1;i<prmax;i++) pr[i].setkeynum(pr[0].key_num);
			  SendMessage (hwnd, WM_COMMAND, IDC_setkey , 0) ;
			  break;

		  case IDC_next_item:
			  pr[0].itemplus(prmax);
			  SendMessage (hwnd, WM_COMMAND, IDC_setkey , 0) ;
			  break;

		  case IDC_setkey:
				 SetDlgItemText(hwnd,IDC_key, pr[0].key);
				  SetDlgItemText(hwnd,IDC_item, pr[0].item);
				  SetDlgItemText(hwnd,IDC_value, pr[0].value);
			  for(i=1;i<prmax;i++) 
			  {
				  pr[i].setitemnum(pr[0].item_num+i-1);
				  pr[i].nextitem();
				  SetDlgItemText(hwnd,IDC_item+i, pr[i].item);
				  SetDlgItemText(hwnd,IDC_value+i, pr[i].value);
			  }
			  break;

		  case IDC_load:
			  GetDlgItemText(hwnd,IDC_key,pr[0].key,MAX_PATH);
			  GetDlgItemText(hwnd,IDC_item,pr[0].item,MAX_PATH);
			  //GetDlgItemText(hwnd,IDC_key,pr.key,MAX_PATH);
			  GetInitialData(pr[0].file,&(pr[0]), value);
			  SetDlgItemText(hwnd,IDC_value, value);
			  break;

		  case IDC_reset:
				SetDlgItemText(hwnd,IDC_key, "");
			  for(i=1;i<prmax;i++) {
				  SetDlgItemText(hwnd,IDC_value+i, "");
				  SetDlgItemText(hwnd,IDC_item+i, "");
			  }
			  break;


		  case IDC_save:
		  case IDC_save2:
		  case IDC_save3:
		  case IDC_save4:
		  case IDC_save5:
		  case IDC_save6:
		  case IDC_save7:
		  case IDC_save8:
		  case IDC_save9:
		  case IDC_save10:
		  case IDC_save11:
		  case IDC_save12:
		  case IDC_save13:
			  i=LOWORD (wParam)-IDC_save;
			  GetDlgItemText(hwnd,IDC_file,pr[i].file,MAX_PATH);
			  GetDlgItemText(hwnd,IDC_key,pr[i].key,MAX_PATH);
			  GetDlgItemText(hwnd,IDC_item+i,pr[i].item,MAX_PATH);
			  GetDlgItemText(hwnd,IDC_value+i,value,MAX_PATH);
			  if(MessageBox(hwnd, value, "ۑ܂", MB_OKCANCEL)==IDOK) SetInitialData(pr[0].file,&(pr[i]), value);
			  break;

		  case IDCANCEL:
			  EndDialog (hwnd, 0) ;
			  break;
          }
          break ;

	 case WM_PAINT:

		 /*Ă
		hdc=BeginPaint(hwnd,&paintstruct);
		SelectObject(hdc,GetStockObject(WHITE_PEN));
		EndPaint(hwnd,&paintstruct);
		//ReleaseDC(hwnd,hdc);
		*/
		 break;

     case WM_SYSCOMMAND:
          switch (LOWORD (wParam))
          {
          case SC_CLOSE:
			  //XbhI
               EndDialog (hwnd, 0) ;
			   //ondestroy(initial);
               return TRUE ;
          }
          break ;
     }
     return FALSE ;
}
