
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include <wininet.h>
#include <windowsx.h>
/*
*/
#include <commctrl.h>
//#include "hwnd.h"
#include "resource.h"
#include "initedit.h"
#include "initial.h"
#include "file.h"
#include "main.h"


char cdir[MAX_PATH];
//char buffer[MAX_PATH];
char initfile[MAX_PATH]="initedit.ini";
char initdirfile[MAX_PATH];
char keywindow[]="setting";



#define MAX_INFO MAX_PATH
#define MAX_NAME 50
#define autofilesavemax 10
const int namenummax=50;
char namelist[namenummax][MAX_NAME];
int timeitemsize=14;
int readksize;
const int numlen=10;
const int initcountmax=10000;



#ifdef _DEBUG
	ofstream lo("log.txt");
#endif

void log(char *d)
{
#ifdef _DEBUG
	lo<<d<<endl;
#endif
}


void openinitdir()
{
	ShellExecute(NULL, "open","explorer",cdir, NULL, SW_SHOW);
}

void getinitdirectory()
{
	GetCurrentDirectory(MAX_PATH,cdir);
}


void setdirfile(char *df,char *f)
{
	wsprintf(df,"%s\\%s",cdir,f);
}


//JgfBNg

void getini_cu()
{
	getinitdirectory();

	setdirfile(initdirfile,initfile);
}

char visittime[16];

char* getvisittime()
{
	SYSTEMTIME st;
	char* jikan=visittime;
	char form[]="%04d%02d%02d%02d%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wYear,
		st.wMonth,
		st.wDay,
		st.wHour,
		st.wMinute
	);
	return visittime;
}




void getprofilepos( WINPOS *lpwinpos )
{
	lpwinpos->x = GetPrivateProfileInt(keywindow, "x",0,initdirfile);
	lpwinpos->y = GetPrivateProfileInt(keywindow, "y",0,initdirfile);
	lpwinpos->wx = GetPrivateProfileInt(keywindow, "wx",100,initdirfile);
	lpwinpos->wy = GetPrivateProfileInt(keywindow, "wy",100,initdirfile);
}

void GetInitialData(char *file,profile* pr, char* value)
{
	GetPrivateProfileString(pr->key, pr->item, pr->defaults, value, MAX_INFO, file);
	return;
}

void SetInitialData(char *file,profile* pr, char* value)
{
	WritePrivateProfileString(pr->key, pr->item, value, file);
	return;
}




void MySetInitialData(WINPOS *lpwinpos)
{
	char buffer[MAX_INFO];
	//itoa()
	wsprintf(buffer,"%d",lpwinpos->x);
	WritePrivateProfileString(keywindow, "x", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->y);
	WritePrivateProfileString(keywindow, "y", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->wx);
	WritePrivateProfileString(keywindow, "wx", buffer, initdirfile);
	wsprintf(buffer,"%d",lpwinpos->wy);
	WritePrivateProfileString(keywindow, "wy", buffer, initdirfile);

	return;
}

void profile::getkey()
{
	char buffer[MAX_PATH*2];
	ifstream in(file,ios::nocreate);
	if(!in) return;
	int i=0;
	key[0]=0;
	item[0]=0;
	value[0]=0;
	while(!in.eof())
	{
		in.getline(buffer,MAX_PATH);
		if(buffer[0]=='[') i++;
		if(i==key_num) break;
	}
	if(i<key_num) {key_num=0;}
	else
	{
		char *c=strchr(buffer,']');
		if(c!=NULL) 
		{
			*c=0;
			wsprintf(key,"%s",buffer+1);
		}
	}
};


void profile::getitem()
{
	char buffer[MAX_PATH*2];
	ifstream in(file,ios::nocreate);
	if(!in) return;
	int i=0;
	item[0]=0;
	value[0]=0;
	while(!in.eof())
	{
		in.getline(buffer,MAX_PATH);
		if(buffer[0]=='[') i++;
		if(i==key_num) break;
	}
	i=0;
	while(!in.eof())
	{
		in.getline(buffer,MAX_PATH);
		i++;
		if(buffer[0]=='[') break;
		if(i==item_num) break;
	}
	if(i<item_num) {item_num=0;}
	else
	{
		char *c=strchr(buffer,'=');
		if(c!=NULL) 
		{
			*c=0;
			wsprintf(item,"%s",buffer);
			if(c+1!=NULL)wsprintf(value,"%s",c+1);
		}
	}
};


void profile::reset()
{
	key_num=0;item_num=1;
};

void profile::nextkey()
{
	key_num++;item_num=0;
	getkey();
};

void profile::keyplus(int n)
{
	key_num += n;
	if(key_num < 0) key_num=0;
	item_num =0;
	getkey();
};

void profile::nextitem()
{
	item_num++;
	getkey();
	getitem();
};
void profile::itemplus(int n)
{
	item_num += n;
	getkey();
	getitem();
};